/*̧قDoxygenpɏĂ܂B*/
//! \file *********************************************************************
//!
//! \brief ̧ق͓d͊Ǘײޒ`܂݂܂B
//!
//!  ̕AVR̊ed͓`Ԃ̌`ԐݒƓۯOu̍\ݒ
//!  ܂B
//!
//! - ߲		: AVRpIAR EWAVRGNU GCC
//! - x޲	: AT90USB162, AT90USB82
//!
//! \author	Atmel Corporation	: http://www.atmel.com \n
//!			xFAQ			: http://support.atmel.no/
//!
//! ***************************************************************************

/* 쌠 (c) 2009, Atmel Corporation S\ς݁B
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. ATMEL̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳATMELAVRiƂ̊֌WłĕzĎgp邱Ƃł܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * ATMELɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂATMEL̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂATMELɐӔC
 * Ȃł傤B
 */

#ifndef _POWER_DRV_H_
#define _POWER_DRV_H_

#ifdef  __GNUC__
  #include <avr/power.h>
#endif

#ifdef __GNUC__
#ifndef CLKSEL0
  #define CLKSEL0	_SFR_MEM8(0XD0)
#endif
#ifndef CLKSEL1
  #define CLKSEL1	_SFR_MEM8(0XD1)
#endif
#ifndef CLKSTA
  #define CLKSTA	_SFR_MEM8(0XD2)
#endif
#endif

//! @defgroup powermode d͊Ǘײ
//!
//! @{

//_____ ϸ ________________________________________________________________

#define Setup_idle_mode()					(SMCR=0,SMCR |= (1<<SE))
#define Setup_power_down_mode()				(SMCR=0,SMCR |= (1<<SE)+(1<<SM1))
#define Setup_adc_noise_reduction_mode()	(SMCR=0,SMCR |= (1<<SE)+(1<<SM0))
#define Setup_power_save_mode()				(SMCR=0,SMCR |= (1<<SE)+(1<<SM1)+(1<<SM0))
#define Setup_standby_mode()				(SMCR=0,SMCR |= (1<<SE)+(1<<SM2)+(1<<SM1))
#define Setup_ext_standby_mode()			(SMCR=0,SMCR |= (1<<SE)+(1<<SM2)+(1<<SM1)+(1<<SM0))

//! Clear_prescaler
//!
//! ̊֐͓CPU ۯOuؾĂ܂B
//!
//! @param	Ȃ
//!
//! @return	Ȃ
//!

#ifdef  __GNUC__
  #define Clear_prescaler()					(clock_prescale_set(0))
#else
  #define Clear_prescaler()					(Set_cpu_prescaler(0))
#endif

//! Set_prescaler
//!
//! ̊֐͓CU ۯOul`Ԑݒ肵܂B
//!
//! @param x: VOul
//!
//! @return	Ȃ
//!
#ifdef  __GNUC__
  #define Set_cpu_prescaler(x)				(clock_prescale_set(x))
#else
  extern void Set_cpu_prescaler (U8 x);
#endif

#define Sleep_instruction()				{asm("SLEEP");}

// ߋ݊
#define Set_power_down_mode()			set_power_down_mode()
#define Set_idle_mode()					set_idle_mode()

//_____ 錾 _______________________________________________________________

void set_idle_mode (void);
void set_power_down_mode (void);
void set_adc_noise_reduction_mode (void);
void set_power_save_mode (void);
void set_standby_mode (void);
void set_ext_standby_mode (void);

//! Enter_idle_mode
//!
//! ̊֐AVRٓɈڍs܂B
//!
//! @param	Ȃ
//!
//! @return	Ȃ
//!
#define Enter_idle_mode()					(set_idle_mode())

//! Enter_power_down_mode
//!
//! ̊֐AVRܰ޳ݓɈڍs܂B
//!
//! @param	Ȃ
//!
//! @return	Ȃ
//!
#define Enter_power_down_mode()				(set_power_down_mode())

//! Enter_adc_noise_reduction_mode
//!
//! ̊֐AVRA/DϊGጸɈڍs܂B
//!
//! @param	Ȃ
//!
//! @return	Ȃ
//!
#define Enter_adc_noise_reduction_mode()	(set_adc_noise_reduction_mode())

//! Enter_power_save_mode
//!
//! ̊֐AVRܰޓɈڍs܂B
//!
//! @param	Ȃ
//!
//! @return	Ȃ
//!
#define Enter_power_save_mode()				(set_power_save_mode())

//! Enter_standby_mode
//!
//! ̊֐AVR޲Ɉڍs܂B
//!
//! @param	Ȃ
//!
//! @return	Ȃ
//!
#define Enter_standby_mode()				(set_standby_mode())

//! Enter_ext_standby_mode
//!
//! ̊֐AVRg޲Ɉڍs܂B
//!
//! @param	Ȃ
//!
//! @return	Ȃ
//!
#define Enter_ext_standby_mode()			(set_ext_standby_mode())

//! @}

//! @defgroup clockmode ۯǗײ
//!
//! @{

//_____ ϸ ________________________________________________________________

// ۯ
#define Enable_external_clock()				(CLKSEL0 |= (1<<EXTE))
#define Disable_external_clock()			(CLKSEL0 &= ~(1<<EXTE))
#define Enable_RC_clock()					(CLKSEL0 |= (1<<RCE))
#define Disable_RC_clock()					(CLKSEL0 &= ~(1<<RCE))

// ۯ
#define External_clock_ready()				(((CLKSTA&(1<<EXTON)) != 0) ? TRUE : FALSE)
#define RC_clock_ready()					(((CLKSTA&(1<<RCON)) != 0) ? TRUE : FALSE)

// ۯI
#define Select_external_clock()				(CLKSEL0 |= (1<<CLKS))
#define Select_RC_clock()					(CLKSEL0 &= ~(1<<CLKS))

// ۯݒ:ۯgpA̸ۯݒ肾ύX邱Ƃł܂B
// ɐ؂芷OɎgp鎟̸ۯ̋ݒݒ肵ĂB
#define Load_ext_clock_config(cfg)			(CLKSEL1 = (CLKSEL1&0xF0) | ((cfg&0x0F)<<EXCKSEL0), \
											 CLKSEL0 = (CLKSEL0&0xCF) | (((cfg&0x30)>>4)<<EXSUT0))

#define Load_RC_clock_config(cfg)			(CLKSEL1 = (CLKSEL1&0x0F) | ((cfg&0x0F)<<RCCKSEL0), \
											 CLKSEL0 = (CLKSEL0&0x3F) | (((cfg&0x30)>>4)<<RCSUT0))

//_____ ۯ` ___________________________________________________________
// SUT<1:0>CKSEL<3:0>(CKSEL0ŉޯ)ƂĒ``Ԑݒ޲

// RCU(7.3`8.1MHzԂ̎g)
#define OSC_INTRC_0MS						0x02
#define OSC_INTRC_4MS						0x12
#define OSC_INTRC_65MS						0x22

// OؽفA0.3`0.9MHzԂ̎g
#define OSC_XTAL_RANGE1_258CK_4MS			0x08
#define OSC_XTAL_RANGE1_258CK_65MS			0x18
#define OSC_XTAL_RANGE1_1KCK_0MS			0x28
#define OSC_XTAL_RANGE1_1KCK_4MS			0x38
#define OSC_XTAL_RANGE1_1KCK_65MS			0x09
#define OSC_XTAL_RANGE1_16KCK_0MS			0x19
#define OSC_XTAL_RANGE1_16KCK_4MS			0x29
#define OSC_XTAL_RANGE1_16KCK_65MS			0x39

// OؽفA0.9`3MHzԂ̎g
#define OSC_XTAL_RANGE2_258CK_4MS			0x0A
#define OSC_XTAL_RANGE2_258CK_65MS			0x1A
#define OSC_XTAL_RANGE2_1KCK_0MS			0x2A
#define OSC_XTAL_RANGE2_1KCK_4MS			0x3A
#define OSC_XTAL_RANGE2_1KCK_65MS			0x0B
#define OSC_XTAL_RANGE2_16KCK_0MS			0x1B
#define OSC_XTAL_RANGE2_16KCK_4MS			0x2B
#define OSC_XTAL_RANGE2_16KCK_65MS			0x3B

// OؽفA3`8MHzԂ̎g
#define OSC_XTAL_RANGE3_258CK_4MS			0x0C
#define OSC_XTAL_RANGE3_258CK_65MS			0x1C
#define OSC_XTAL_RANGE3_1KCK_0MS			0x2C
#define OSC_XTAL_RANGE3_1KCK_4MS			0x3C
#define OSC_XTAL_RANGE3_1KCK_65MS			0x0D
#define OSC_XTAL_RANGE3_16KCK_0MS			0x1D
#define OSC_XTAL_RANGE3_16KCK_4MS			0x2D
#define OSC_XTAL_RANGE3_16KCK_65MS			0x3D

// OؽفA8`16MHzԂ̎g
#define OSC_XTAL_RANGE4_258CK_4MS			0x0E
#define OSC_XTAL_RANGE4_258CK_65MS			0x1E
#define OSC_XTAL_RANGE4_1KCK_0MS			0x2E
#define OSC_XTAL_RANGE4_1KCK_4MS			0x3E
#define OSC_XTAL_RANGE4_1KCK_65MS			0x0F
#define OSC_XTAL_RANGE4_16KCK_0MS			0x1F
#define OSC_XTAL_RANGE4_16KCK_4MS			0x2F
#define OSC_XTAL_RANGE4_16KCK_65MS			0x3F

// OۯM
#define OSC_EXTCLK_0MS						0x00
#define OSC_EXTCLK_4MS						0x10
#define OSC_EXTCLK_65MS						0x20

//_____ 錾 _______________________________________________________________

void Clock_switch_external (void);
void Clock_switch_internal (void);

//! @}

#endif // _POWER_DRV_H_
